function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { Drawer } from 'antd';
import { useState, useMemo, useRef, useEffect } from 'react';
import Modal from "../../../pisellModal";
var sizeMap = {
  small: 400,
  middle: 600,
  large: 800
};
var useDrawerState = function useDrawerState(operationContent) {
  // 抽屉是否显示
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    drawerVisible = _useState2[0],
    setDrawerVisible = _useState2[1];
  var _useState3 = useState(null),
    _useState4 = _slicedToArray(_useState3, 2),
    item = _useState4[0],
    setItem = _useState4[1];
  var timerRef = useRef();

  // 组件卸载时清除定时器
  useEffect(function () {
    return function () {
      if (timerRef.current) {
        clearTimeout(timerRef.current);
      }
    };
  }, []);
  var openDrawer = function openDrawer(item) {
    // 如果存在未完成的定时器，先清除
    if (timerRef.current) {
      clearTimeout(timerRef.current);
    }
    setDrawerVisible(true);
    setItem(item);
  };
  var closeDrawer = function closeDrawer() {
    // 如果存在未完成的定时器，先清除
    if (timerRef.current) {
      clearTimeout(timerRef.current);
    }
    setDrawerVisible(false);
    // 等待动画完成后再清除item
    timerRef.current = setTimeout(function () {
      setItem(null);
      timerRef.current = undefined;
    }, 300);
  };

  // 抽屉内容
  var drawerContent = useMemo(function () {
    if (item !== null && item !== void 0 && item.key && operationContent) {
      return operationContent[item.key];
    }
    return null;
  }, [item, operationContent]);

  // 容器属性
  var containerProps = useMemo(function () {
    if (!item) {
      return {};
    }
    var otherProps = {};
    if ((item === null || item === void 0 ? void 0 : item.openMode) === 'modal') {
      otherProps.footer = null;
    }
    return _objectSpread({
      width: sizeMap[item === null || item === void 0 ? void 0 : item.openContentSize],
      title: item === null || item === void 0 ? void 0 : item.openTitle
    }, otherProps);
  }, [item]);
  var Container = useMemo(function () {
    if ((item === null || item === void 0 ? void 0 : item.openMode) === 'drawer') {
      return Drawer;
    }
    return Modal;
  }, [item === null || item === void 0 ? void 0 : item.openMode]);
  return {
    drawerVisible: drawerVisible,
    setDrawerVisible: setDrawerVisible,
    openDrawer: openDrawer,
    closeDrawer: closeDrawer,
    drawerContent: drawerContent,
    Container: Container,
    containerProps: containerProps
  };
};
export default useDrawerState;